<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- joblimit.qdoc -->
  <title>JobLimit QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="qml-qbslanguageitems-group.html" />
  <link rel="next" href="qml-qbslanguageitems-module.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="qml-qbslanguageitems-group.html">Group</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-module.html">Module</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">JobLimit QML Type</h1>
<span class="subtitle"></span>
<!-- $$$JobLimit-brief -->
<p>Restricts concurrent execution of jobs in a given pool. <a href="#details">More...</a></p>
<!-- @@@JobLimit -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-joblimit-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-joblimit.html#condition-prop">condition</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-joblimit.html#jobCount-prop">jobCount</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-joblimit.html#jobPool-prop">jobPool</a></b></b> : string</li>
</ul>
<!-- $$$JobLimit-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>In addition to the global limit on concurrently running commands, a project might want to restrict concurrent execution of certain types of commands even further, for instance because they are not well-suited to share certain types of resources.</p>
<p>In the following example, we define a rule that runs a tool of which at most one instance can be running for the same project at any given time:</p>
<pre class="cpp">

  Rule {
      <span class="comment">// ...</span>
      prepare: {
          var cmd <span class="operator">=</span> <span class="keyword">new</span> Command(<span class="string">&quot;my-exclusive-tool&quot;</span><span class="operator">,</span> <span class="operator">[</span>project<span class="operator">.</span>buildDirectory<span class="operator">]</span>);
          cmd<span class="operator">.</span>description <span class="operator">=</span> <span class="string">&quot;running the exclusive tool&quot;</span>;
          cmd<span class="operator">.</span>jobPool <span class="operator">=</span> <span class="string">&quot;exclusive_tool&quot;</span>;
          <span class="keyword">return</span> cmd;
      }
  }
  JobLimit {
      jobPool: <span class="string">&quot;exclusive_tool&quot;</span>
      jobCount: <span class="number">1</span>
  }

</pre>
<p><code>JobLimit</code> items can appear inside <a href="qml-qbslanguageitems-product.html">Product</a>, <a href="qml-qbslanguageitems-project.html">Project</a> and <a href="qml-qbslanguageitems-module.html">Module</a> items. In the case of collisions, that is, items matching the same job pool but setting different values, the ones defined inside products have the highest precedence, and the ones inside modules have the lowest. Items defined in sub-projects have higher precedence than those defined in parent projects. For items with the same precedence level, the most restrictive one is chosen, that is, the one with the lowest job number greater than zero.</p>
<p><b>See also </b><a href="howtos.html#how-do-i-limit-the-number-of-concurrent-jobs-for-the-linker-only">How do I limit the number of concurrent jobs for the linker only?</a>.</p>
<!-- @@@JobLimit -->
<h2>Property Documentation</h2>
<!-- $$$condition -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="condition-prop">
<td class="tblQmlPropNode"><p>
<span class="name">condition</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Determines whether the job limit is active.</p>
<p>If this property is set to <code>false</code>, the job limit is ignored.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@condition -->
<br/>
<!-- $$$jobCount -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="jobCount-prop">
<td class="tblQmlPropNode"><p>
<span class="name">jobCount</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The maximum number of commands in the given <a href="qml-qbslanguageitems-joblimit.html#jobPool-prop">job pool</a> that can run concurrently.</p>
<p>A value of zero means &quot;unlimited&quot;, negative values are not allowed.</p>
<p><b>Note: </b>The global job limit always applies: For instance, if you set this property to 100 for some job pool, and &quot;-j 8&quot; was given on the command line, then no more than eight instances of commands from the respective job pool will run at any time.</p><p>This property must always be set.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@jobCount -->
<br/>
<!-- $$$jobPool -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="jobPool-prop">
<td class="tblQmlPropNode"><p>
<span class="name">jobPool</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The job pool to which apply the limit.</p>
<p>This property must always be set to a non-empty value.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@jobPool -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="qml-qbslanguageitems-group.html">Group</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-module.html">Module</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
